import { _decorator, Component, director, instantiate, Node, Prefab } from 'cc';
import { app } from './App';
import { JNGame } from '../../extensions/ngame/assets/ngame/JNGame';
import { JNSyncAction } from '../../extensions/ngame/assets/ngame/sync/JNSyncAction';
import { TableGRole } from '../resources/config/ts/TableGRole';
import { PhysicsSystem2D } from 'cc';
import { EPhysics2DDrawFlags } from 'cc';
import { find } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('Main')
export class Main extends Component {

    @property(Prefab)
    UIPrefab: Prefab = null;

    @property(Prefab)
    WorldPrefab: Prefab = null;

    async onLoad(){

        //加载 APP
        await JNGame.Init(app,[
            {path:"proto/GDemo"}
        ]);

        console.log("TableGRole",TableGRole.getAllConfig())

        //发生帧同步开始
        app.socket.Send(JNSyncAction.NSyncFrameStart);

        // 创建UI
        director.getScene().addChild(instantiate(this.UIPrefab));
        // 创建世界
        director.getScene().addChild(instantiate(this.WorldPrefab));

    }

}


