import { _decorator } from "cc";
import GRoleBase from "../GRoleBase";
import GFSMPVP from "../../fsm/PVP/GFSMPVP";
import GPVPMode, { GPVPModePlayerEnum } from "../../../modes/GPVPMode";
import { GFSMBattleAmin } from "../../fsm/base/GFSMBattle/GFSMBattleAmin";
import { JNFrameInfo } from "../../../../../../extensions/ngame/assets/ngame/sync/frame/JNSyncFrame";
import { ProgressBar } from "cc";
const { ccclass, property } = _decorator;

export interface GDemoMessage{
    isAttack?:boolean;
    isRun?:boolean;
}

//PVP 角色
@ccclass('GRolePVPEntity')
export default class GRolePVPEntity extends GRoleBase<GDemoMessage>{

    //所属阵容
    _ones:GPVPModePlayerEnum;
    get ones():GPVPModePlayerEnum{
        return this._ones;
    }
    set ones(value:GPVPModePlayerEnum){
        this._ones = value;
    }

    @property(ProgressBar)
    bloodVolume:ProgressBar;

    //能量条
    @property(ProgressBar)
    energyVolume:ProgressBar;

    onSyncLoad(){
        super.onSyncLoad();
    }

    getClassName():string{return "GDemoMessage"}
    onSyncUpdate(dt: number,frame:JNFrameInfo, input?: GDemoMessage) { 
        super.onSyncUpdate(dt,frame,input);

        if(input){
            if(Object.prototype.hasOwnProperty.call(input,"isAttack")){
                this.fsmAnim.isAttack = input.isAttack;
            }
            if(Object.prototype.hasOwnProperty.call(input,"isRun")){
                this.fsmAnim.isMove = input.isRun;
            }
        }

        //更新显示
        this.bloodVolume.progress =  this.blood / this.fullBlood;
        //显示第一个技能进度条
        if(this.skills[0]){
            this.energyVolume.progress =  this.skills[0].getProgress();
        }
    }
    

    get mode():GPVPMode{
        return super.mode as GPVPMode;
    }
    set mode(value:GPVPMode){
        this._mode = value;
    }

    
    protected fsmCreate(): GFSMPVP {
        return new GFSMPVP(this);
    }
    protected fsmAnimCreate(): GFSMBattleAmin {
        return new GFSMBattleAmin(this.spine);
    }

    //添加死亡销毁
    onHit(){
        super.onHit();
        if(this.isDie){
            //销毁数据
            this.mode.killRole(this);
        }
    }
    
}

